﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Agis
{
    public partial class Form1 : Form
    {
        [DllImport("user32.dll", EntryPoint = "GetSystemMetrics")]
        public static extern int GetSystemMetrics(int nIndex);

        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        static extern void mouse_event(uint dwFlags, int dx, int dy, uint dwData, int dwExtraInfo);

        [DllImport("user32.dll")]
        static extern bool SetCursorPos(int X, int Y);

        [DllImport("user32.dll")]
        private static extern IntPtr GetForegroundWindow();

        public const int MOUSEEVENTF_LEFTDOWN = 0x02;
        public const int MOUSEEVENTF_LEFTUP = 0x04;
        public const int MOUSEEVENTF_RIGHTDOWN = 0x08;
        public const int MOUSEEVENTF_RIGHTUP = 0x10;


        public Form3 f3 = null;
        public Form6 f6 = null;
        public Form8 f8 = null;
        public IntPtr agis;

        public Form1()
        {
            InitializeComponent();
        }

        private void newMacro_CheckedChanged(object sender, EventArgs e)
        {
            buttNewMacro.Enabled = true;

            existDelMacros.Items.Clear();
            existDelMacros.Text = "";
            existDelMacros.Enabled = false;
            buttDelMacro.Enabled = false;

            existRunMacros.Items.Clear();
            existRunMacros.Text = "";
            existRunMacros.Enabled = false;
            buttRunMacro.Enabled = false;

            macroResolution.Items.Clear();
            macroResolution.Text = "";
            macroResolution.Enabled = false;
            macroName.Items.Clear();
            macroName.Text = "";
            macroName.Enabled = false;
            buttEditMacro.Enabled = false;

            buttConversion.Enabled = false;
        }

        private void deleteMacro_CheckedChanged(object sender, EventArgs e)
        {
            buttNewMacro.Enabled = false;

            existDelMacros.Enabled = true;
            buttDelMacro.Enabled = true;
            if (Directory.Exists("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
            {
                foreach (String s in Directory.EnumerateFiles("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
                {
                    existDelMacros.Items.Add(s.Substring(0, s.Length - 4));
                }
                if (existDelMacros.Items.Count > 0)
                    existDelMacros.SelectedIndex = 0;
            }

            existRunMacros.Items.Clear();
            existRunMacros.Text = "";
            existRunMacros.Enabled = false;
            buttRunMacro.Enabled = false;

            macroResolution.Items.Clear();
            macroResolution.Text = "";
            macroResolution.Enabled = false;
            macroName.Items.Clear();
            macroName.Text = "";
            macroName.Enabled = false;
            buttEditMacro.Enabled = false;

            buttConversion.Enabled = false;
        }

        private void runMacro_CheckedChanged(object sender, EventArgs e)
        {
            buttNewMacro.Enabled = false;

            existDelMacros.Items.Clear();
            existDelMacros.Text = "";
            existDelMacros.Enabled = false;
            buttDelMacro.Enabled = false;

            existRunMacros.Enabled = true;
            buttRunMacro.Enabled = true;
            if (Directory.Exists("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
            {
                foreach (String s in Directory.EnumerateFiles("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
                {
                    existRunMacros.Items.Add(s.Substring(0, s.Length - 4));
                }
                if (existRunMacros.Items.Count > 0)
                    existRunMacros.SelectedIndex = 0;
            }

            macroResolution.Items.Clear();
            macroResolution.Text = "";
            macroResolution.Enabled = false;
            macroName.Items.Clear();
            macroName.Text = "";
            macroName.Enabled = false;
            buttEditMacro.Enabled = false;

            buttConversion.Enabled = false;
        }

        private void changeMacroResolution_CheckedChanged(object sender, EventArgs e)
        {
            buttNewMacro.Enabled = false;

            existDelMacros.Items.Clear();
            existDelMacros.Text = "";
            existDelMacros.Enabled = false;
            buttDelMacro.Enabled = false;

            existRunMacros.Items.Clear();
            existRunMacros.Text = "";
            existRunMacros.Enabled = false;
            buttRunMacro.Enabled = false;

            macroResolution.Enabled = true;
            if (Directory.Exists("Macros"))
            {
                foreach (String s in Directory.EnumerateDirectories("Macros"))
                {
                    string r = s.Substring(s.LastIndexOf("\\") + 1, s.Length - s.LastIndexOf("\\") - 1);
                    int x = int.Parse(r.Substring(0, r.IndexOf(" ")));
                    int y = int.Parse(r.Substring(r.IndexOf(" ") + 1, r.Length - r.IndexOf(" ") - 1));

                    if (!(x == GetSystemMetrics(0) && y == GetSystemMetrics(1)))
                        macroResolution.Items.Add(s);
                }
                if (macroResolution.Items.Count > 0)
                    macroResolution.SelectedIndex = 0;
            }
            macroName.Enabled = true;
            buttConversion.Enabled = false;
        }

        private void macroResolution_SelectedValueChanged(object sender, EventArgs e)
        {
            macroName.Items.Clear();
            if (Directory.Exists(macroResolution.Text))
            {
                foreach (String s in Directory.EnumerateFiles(macroResolution.Text))
                {
                    macroName.Items.Add(s.Substring(0, s.Length - 4));
                }
                if (macroName.Items.Count > 0)
                    macroName.SelectedIndex = 0;
            }
            if (macroName.Items.Count > 0)
                buttEditMacro.Enabled = true;
            else
                buttEditMacro.Enabled = false;
        }

        private void conversion_CheckedChanged(object sender, EventArgs e)
        {
            buttNewMacro.Enabled = false;

            existDelMacros.Items.Clear();
            existDelMacros.Text = "";
            existDelMacros.Enabled = false;
            buttDelMacro.Enabled = false;

            existRunMacros.Items.Clear();
            existRunMacros.Text = "";
            existRunMacros.Enabled = false;
            buttRunMacro.Enabled = false;

            macroResolution.Items.Clear();
            macroResolution.Text = "";
            macroResolution.Enabled = false;
            macroName.Items.Clear();
            macroName.Text = "";
            macroName.Enabled = false;
            buttEditMacro.Enabled = false;

            buttConversion.Enabled = true;

        }

        private void buttNewMacro_Click(object sender, EventArgs e)
        {
            ArrayList macros = new ArrayList();
            if (!Directory.Exists("Macros"))
            {
                Directory.CreateDirectory("Macros");
            }
            if (!Directory.Exists("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
            {
                Directory.CreateDirectory("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1));
            }
            foreach (String s in Directory.EnumerateFiles("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
            {
                macros.Add(s.Substring(0, s.Length - 4));
            }
            Form2 f = new Form2("Nové makro", "Zadejte jméno nového makra");
            string name = "";
            f.ShowDialog();
            name = f.ret;
            if (!name.Equals(""))
            {
                name = "Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1) + "\\" + name;
                if (!macros.Contains(name))
                {
                    this.Visible = false;
                    StreamWriter sw = new StreamWriter(name + ".txt", false, Encoding.UTF8);
                    sw.Close();
                    macros.Add(name);
                    f3 = new Form3(0);
                    f3.ShowDialog();
                    sw = new StreamWriter(name + ".txt", false, Encoding.UTF8);
                    sw.WriteLine(f3.sb.ToString());
                    sw.Close();
                    f3.Dispose();
                    f3 = null;
                    this.Visible = true;
                    SetForegroundWindow(this.Handle);
                }
                else
                {
                    MessageBox.Show("Makro s tímto jménem již existuje, chcete-li ho změnit smažte staré", "Makro již existuje", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
        }

        private void buttDelMacro_Click(object sender, EventArgs e)
        {
            if (File.Exists(existDelMacros.Text + ".txt"))
            {
                if (MessageBox.Show("Opravdu chcete smazat makro " + existDelMacros.Text + "?", "Smazat makro", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    File.Delete(existDelMacros.Text + ".txt");
                    existDelMacros.Items.Remove(existDelMacros.Text);
                    if (existDelMacros.Items.Count > 0)
                    {
                        existDelMacros.Text = existDelMacros.Items[0].ToString();
                    }
                    else
                    {
                        existDelMacros.Text = "";
                    }
                }
            }
        }

        private void buttRunMacro_Click(object sender, EventArgs e)
        {
            if (File.Exists(existRunMacros.Text + ".txt"))
            {
                this.Visible = false;
                Process[] p = Process.GetProcessesByName("ArcMap");
                try
                {
                    agis = p[0].MainWindowHandle;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("ArcGis není spuštěn, není možné spustit makro");
                }
                SetForegroundWindow(agis);
                System.Threading.Thread.Sleep(1000);
                StreamReader sr = new StreamReader(existRunMacros.Text + ".txt", Encoding.UTF8);
                while (!sr.EndOfStream)
                {
                    string pr = sr.ReadLine();
                    if (pr != "")
                    {
                        runCommand(pr);
                    }
                }
                sr.Close();
                this.Visible = true;
                SetForegroundWindow(this.Handle);
            }
        }

        private void runCommand(string pr)
        {
            switch (pr[0])
            {
                case 'M':
                    {
                        int clX = int.Parse(pr.Substring(3, pr.IndexOf(",") - 3));
                        int clY = int.Parse(pr.Substring(pr.IndexOf(",") + 1, pr.Length - pr.IndexOf(",") - 1));
                        SetCursorPos(clX, clY);
                        if (pr[1] == 'm')
                        {
                            System.Threading.Thread.Sleep(10);
                        }
                        else if (pr[1] == 'l')
                        {
                            if (pr[2] == 'd')
                            {
                                System.Threading.Thread.Sleep(10);
                                mouse_event(MOUSEEVENTF_LEFTDOWN, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                            }
                            else
                            {
                                mouse_event(MOUSEEVENTF_LEFTUP, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                                System.Threading.Thread.Sleep(1000);
                            }
                        }
                        else
                        {
                            if (pr[2] == 'd')
                            {
                                System.Threading.Thread.Sleep(10);
                                mouse_event(MOUSEEVENTF_RIGHTDOWN, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                            }
                            else
                            {
                                mouse_event(MOUSEEVENTF_RIGHTUP, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                                System.Threading.Thread.Sleep(1000);
                            }
                        }
                        System.Threading.Thread.Sleep(1);
                        break;
                    }

                case 'K':
                    {
                        SendKeys.SendWait(pr.Substring(3, pr.Length - 3));
                        break;
                    }
                case 'T':
                    {
                        string rad = pr.Substring(3, pr.Length - 3);
                        string[] splBy = { "////" };
                        string[] splited = rad.Split(splBy, StringSplitOptions.None);
                        Form5 f5 = new Form5(splited);
                        SetForegroundWindow(f5.Handle);
                        f5.ShowDialog();
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
        }

        private string changeCommand(string pr, int r1, int r2)
        {
            StringBuilder res = new StringBuilder(pr);
            switch (pr[0])
            {
                case 'M':
                    {
                        int clX = int.Parse(pr.Substring(3, pr.IndexOf(",") - 3));
                        clX = changeRes(clX, r1, GetSystemMetrics(0));
                        int clY = int.Parse(pr.Substring(pr.IndexOf(",") + 1, pr.Length - pr.IndexOf(",") - 1));
                        clY = changeRes(clY, r2, GetSystemMetrics(1));
                        if (pr[1] == 'm')
                        {
                            res.Clear();
                            res.Append("Mm ");
                            res.Append(clX);
                            res.Append(",");
                            res.Append(clY);
                        }
                        else if (pr[1] == 'l')
                        {
                            if (pr[2] == 'd')
                            {
                                res.Clear();
                                res.Append("Mld");
                                res.Append(clX);
                                res.Append(",");
                                res.Append(clY);
                            }
                            else
                            {
                                res.Clear();
                                res.Append("Mlu");
                                res.Append(clX);
                                res.Append(",");
                                res.Append(clY);
                            }
                        }
                        else
                        {
                            if (pr[2] == 'd')
                            {
                                res.Clear();
                                res.Append("Mrd");
                                res.Append(clX);
                                res.Append(",");
                                res.Append(clY);
                            }
                            else
                            {
                                res.Clear();
                                res.Append("Mlu");
                                res.Append(clX);
                                res.Append(",");
                                res.Append(clY);
                            }
                        }
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
            return res.ToString();
        }

        private void buttEditMacro_Click(object sender, EventArgs e)
        {
            this.Visible = false;
            ArrayList macros = new ArrayList();
            if (!Directory.Exists("Macros"))
            {
                Directory.CreateDirectory("Macros");
            }
            if (!Directory.Exists("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
            {
                Directory.CreateDirectory("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1));
            }
            foreach (String s in Directory.EnumerateFiles("Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1)))
            {
                macros.Add(s.Substring(0, s.Length - 4));
            }
            string name = macroName.SelectedItem.ToString();
            name = name.Substring(name.LastIndexOf('\\') + 1, name.Length - name.LastIndexOf('\\') - 1);
            string resol = macroResolution.SelectedItem.ToString();
            resol = resol.Substring(resol.LastIndexOf('\\') + 1, resol.Length - resol.LastIndexOf('\\') - 1);
            int r1 = int.Parse(resol.Substring(0, resol.IndexOf(" ")));
            int r2 = int.Parse(resol.Substring(resol.IndexOf(" ") + 1, resol.Length - resol.IndexOf(" ") - 1));
            List<List<string>> prikazy = new List<List<string>>();
            string prevCommand = "SSS";
            int index = 0;
            if (!name.Equals(""))
            {
                name = "Macros\\" + GetSystemMetrics(0) + " " + GetSystemMetrics(1) + "\\" + name;
                if (!macros.Contains(name))
                {
                    this.Visible = false;
                    StreamWriter sw = new StreamWriter(name + ".txt", false, Encoding.UTF8);
                    sw.Close();
                    macros.Add(name);
                    StreamReader sr = new StreamReader(macroName.Text + ".txt", Encoding.UTF8);
                    while (!sr.EndOfStream)
                    {
                        string radek = sr.ReadLine();
                        if (!radek.Equals(""))
                        {
                            if (radek.StartsWith("M") || radek.StartsWith("T"))
                            {
                                if (radek.StartsWith("M"))
                                {

                                    int clX = int.Parse(radek.Substring(3, radek.IndexOf(",") - 3));
                                    int clY = int.Parse(radek.Substring(radek.IndexOf(",") + 1, radek.Length - radek.IndexOf(",") - 1));
                                    clX = changeRes(clX, r1, GetSystemMetrics(0));
                                    clY = changeRes(clY, r2, GetSystemMetrics(1));
                                    radek = radek.Substring(0, 3) + clX + "," + clY;
                                }
                                else
                                {
                                    string rad = radek.Substring(3, radek.Length - 3);
                                    string[] splBy = { "////" };
                                    string[] splited = rad.Split(splBy, StringSplitOptions.None);
                                    splited[1] = changeRes(int.Parse(splited[1]), r1, GetSystemMetrics(0)).ToString();
                                    splited[2] = changeRes(int.Parse(splited[2]), r2, GetSystemMetrics(1)).ToString();
                                    radek = "T  " + splited[0] + "////" + splited[1] + "////" + splited[2] + "////" + splited[3] + "////" + splited[4]+"////"+splited[5];
                                }
                            }
                            if (prevCommand != radek.Substring(0, 3) || radek.StartsWith("T") || radek.StartsWith("K"))
                            {
                                prikazy.Add(new List<string>());
                                prikazy[index].Add(radek);
                                index += 1;
                                prevCommand = radek.Substring(0, 3);
                            }
                            else
                            {
                                prikazy[index - 1].Add(radek);
                                prevCommand = radek.Substring(0, 3);
                            }
                        }
                    }

                    f8 = new Form8(prikazy);
                    f8.ShowDialog();
                    sw = new StreamWriter(name + ".txt", true, Encoding.UTF8);
                    sw.WriteLine(f8.sb.ToString());
                    sw.Close();
                    f8.Dispose();
                    f8 = null;
                    this.Visible = true;
                    SetForegroundWindow(this.Handle);
                }
                else
                {
                    MessageBox.Show("Makro s tímto jménem již existuje, chcete-li ho změnit smažte staré", "Makro již existuje", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                this.Visible = true;
                SetForegroundWindow(this.Handle);
            }
        }


        private int changeRes(double i, double baseRes, double newRes)
        {
            if (baseRes == newRes)
                return (int)i;
            else
                return (int)Math.Round((newRes / baseRes) * i);
        }

        private void buttConversion_Click(object sender, EventArgs e)
        {
            this.Visible = false;
            f6 = new Form6();
            f6.ShowDialog();
            f6 = null;
            this.Visible = true;
            this.Show();
        }


    }
}
