﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Agis
{
    public partial class Form6 : Form
    {

        [DllImport("user32.dll", EntryPoint = "GetSystemMetrics")]
        public static extern int GetSystemMetrics(int nIndex);

        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        private IntPtr agis;
        internal Bitmap myBitmap = null;
        private Color baseColor;
        private bool setColor = false;

        Form7 f7 = null;
        public Form6()
        {
            InitializeComponent();
        }

        private void form6_Load(object sender, EventArgs e)
        {
            this.Visible = false;
            Process[] p = Process.GetProcessesByName("ArcMap");
            try
            {
                agis = p[0].MainWindowHandle;
                SetForegroundWindow(agis);
                System.Threading.Thread.Sleep(1000);
                myBitmap = Win32APICall.GetDesktop();
                SetForegroundWindow(this.Handle);
            }
            catch (Exception ex)
            {
            }
            f7 = new Form7(this);
            f7.Show();
            posX.Text = f7.Location.X.ToString();
            posY.Text = f7.Location.Y.ToString();
            boxWidth.Text = f7.Size.Width.ToString();
            boxHeight.Text = f7.Size.Height.ToString();
        }

        public void setBaseColor(int x, int y)
        {
            if (!setColor)
            {
                baseColor = myBitmap.GetPixel(x, y);
                setColor = true;
                chancePicColor();
            }
            posX.Enabled = false;
            barX.Enabled = false;
            posY.Enabled = false;
            barY.Enabled = false;
            boxWidth.Enabled = false;
            barWidth.Enabled = false;
            boxHeight.Enabled = false;
            barHeight.Enabled = false;
            R.Enabled = true;
            G.Enabled = true;
            B.Enabled = true;
            rBar.Enabled = true;
            gBar.Enabled = true;
            bBar.Enabled = true;
            butFindPixel.Enabled = true;
        }

        private void rBar_ValueChanged(object sender, EventArgs e)
        {
            R.Text = rBar.Value.ToString();
            chancePicColor();
        }

        private void gBar_ValueChanged(object sender, EventArgs e)
        {
            G.Text = gBar.Value.ToString();
            chancePicColor();
        }

        private void bBar_ValueChanged(object sender, EventArgs e)
        {
            B.Text = bBar.Value.ToString();
            chancePicColor();
        }

        private void chancePicColor()
        {
            picBaseColor.BackColor = baseColor;
            labBaseColor.Text = baseColor.R + ", " + baseColor.G + ", " + baseColor.B;
            int r = baseColor.R - int.Parse(R.Text);
            int g = baseColor.G - int.Parse(G.Text);
            int b = baseColor.B - int.Parse(B.Text);
            if (r < 0)
            {
                r = 0;
            }
            if (g < 0)
            {
                g = 0;
            }
            if (b < 0)
            {
                b = 0;
            }
            picLowColor.BackColor = Color.FromArgb(baseColor.A, r, g, b);
            labLowColor.Text = r + ", " + g + ", " + b;
            r = baseColor.R + int.Parse(R.Text);
            g = baseColor.G + int.Parse(G.Text);
            b = baseColor.B + int.Parse(B.Text);
            if (r > 255)
            {
                r = 255;
            }
            if (g > 255)
            {
                g = 255;
            }
            if (b > 255)
            {
                b = 255;
            }
            picHighColor.BackColor = Color.FromArgb(baseColor.A, r, g, b);
            labHighColor.Text = r + ", " + g + ", " + b;
        }

        private void R_Validated(object sender, EventArgs e)
        {
            rBar.Value = int.Parse(R.Text);
        }

        private void G_Validated(object sender, EventArgs e)
        {
            gBar.Value = int.Parse(G.Text);
        }
        private void B_Validated(object sender, EventArgs e)
        {
            bBar.Value = int.Parse(B.Text);
        }

        private void Text_Validating(object sender, CancelEventArgs e)
        {
            TextBox t = (TextBox)sender;
            try
            {
                int.Parse(t.Text);
            }
            catch (Exception ex)
            {
                t.Text = "0";

            }
        }

        private void Form6_FormClosing(object sender, FormClosingEventArgs e)
        {
            f7.Close();
            f7.Dispose();
        }

        private void posX_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(posX.Text);
            }
            catch (Exception ex)
            {
                posX.Text = f7.Location.X.ToString();
            }
        }

        private void posX_Validated(object sender, EventArgs e)
        {
            if (int.Parse(posX.Text) + f7.Size.Width > GetSystemMetrics(0))
            {
                f7.Location = new Point(GetSystemMetrics(0) - f7.Width, f7.Location.Y);
                posX.Text = (GetSystemMetrics(0) - f7.Width).ToString();
            }
            else if (int.Parse(posX.Text) < 0)
            {
                f7.Location = new Point(0, f7.Location.Y);
                posX.Text = "0";
            }
            else
                f7.Location = new Point(int.Parse(posX.Text), f7.Location.Y);
        }

        private void posY_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(posY.Text);
            }
            catch (Exception ex)
            {
                posY.Text = f7.Location.Y.ToString();
            }
        }

        private void posY_Validated(object sender, EventArgs e)
        {
            if (int.Parse(posY.Text) + f7.Size.Height > GetSystemMetrics(1))
            {
                f7.Location = new Point(f7.Location.X, GetSystemMetrics(1) - f7.Height);
                posY.Text = (GetSystemMetrics(1) - f7.Height).ToString();
            }
            else if (int.Parse(posY.Text) < 0)
            {
                f7.Location = new Point(f7.Location.X, 0);
                posY.Text = "0";
            }
            else
                f7.Location = new Point(f7.Location.X, int.Parse(posY.Text));
        }

        private void barX_MouseUp(object sender, MouseEventArgs e)
        {
            barX.Value = 50;
        }

        private void barY_MouseUp(object sender, MouseEventArgs e)
        {
            barY.Value = 50;
        }

        private void barX_Scroll(object sender, EventArgs e)
        {
            int set = barX.Value - 50;
            int x = int.Parse(posX.Text);
            int res = x + set;
            if (res < 0)
                res = 0;
            if (res + f7.Size.Width > GetSystemMetrics(0))
                res = GetSystemMetrics(0) - f7.Size.Width;
            posX.Text = res.ToString();
            f7.Location = new Point(int.Parse(posX.Text), f7.Location.Y);
        }

        private void barY_Scroll(object sender, EventArgs e)
        {
            int set = barY.Value - 50;
            int x = int.Parse(posY.Text);
            int res = x + set;
            if (res < 0)
                res = 0;
            if (res + f7.Size.Height > GetSystemMetrics(1))
                res = GetSystemMetrics(1) - f7.Size.Height;
            posY.Text = res.ToString();
            f7.Location = new Point(f7.Location.X, int.Parse(posY.Text));
        }

        private void barWidth_MouseUp(object sender, MouseEventArgs e)
        {
            barWidth.Value = 50;
        }

        private void barWidth_Scroll(object sender, EventArgs e)
        {
            int set = barWidth.Value - 50;
            int x = int.Parse(boxWidth.Text);
            int res = x + set;
            if (res < 1)
                res = 1;
            if (res > 800)
                res = 800;
            boxWidth.Text = res.ToString();
            f7.Size = new Size(int.Parse(boxWidth.Text), f7.Size.Height);
        }

        private void barHeight_MouseUp(object sender, MouseEventArgs e)
        {
            barHeight.Value = 50;
        }

        private void barHeight_Scroll(object sender, EventArgs e)
        {
            int set = barHeight.Value - 50;
            int x = int.Parse(boxHeight.Text);
            int res = x + set;
            if (res < 1)
                res = 1;
            if (res > 600)
                res = 600;
            boxHeight.Text = res.ToString();
            f7.Size = new Size(f7.Size.Width, int.Parse(boxHeight.Text));
        }

        private void boxWidth_Validated(object sender, EventArgs e)
        {
            if (int.Parse(boxWidth.Text) > 800)
            {
                f7.Size = new Size(800, f7.Size.Height);
                posX.Text = "800";
            }
            else if (int.Parse(boxWidth.Text) < 1)
            {
                f7.Size = new Size(0, f7.Size.Height);
                posX.Text = "0";
            }
            else
                f7.Size = new Size(int.Parse(boxWidth.Text), f7.Size.Height);
        }

        private void boxWidth_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(boxWidth.Text);
            }
            catch (Exception ex)
            {
                boxWidth.Text = f7.Size.Width.ToString();
            }
        }

        private void boxHeight_Validated(object sender, EventArgs e)
        {
            if (int.Parse(boxHeight.Text) > 600)
            {
                f7.Size = new Size(f7.Size.Width, 600);
                boxHeight.Text = "600";
            }
            else if (int.Parse(boxHeight.Text) < 0)
            {
                f7.Size = new Size(f7.Size.Width, 0);
                boxHeight.Text = "0";
            }
            else
                f7.Size = new Size(f7.Size.Width, int.Parse(boxHeight.Text));
        }

        private void boxHeight_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(boxHeight.Text);
            }
            catch (Exception ex)
            {
                boxHeight.Text = f7.Size.Height.ToString();
            }
        }

        private void butReset_Click(object sender, EventArgs e)
        {

            f7.Close();
            f7.Dispose();
            this.Visible = false;
            SetForegroundWindow(agis);
            System.Threading.Thread.Sleep(1000);
            myBitmap = Win32APICall.GetDesktop();
            SetForegroundWindow(this.Handle);
            this.Visible = true;
            f7 = new Form7(this);
            f7.Show();
            setColor = false;
            posX.Enabled = true;
            barX.Enabled = true;
            posY.Enabled = true;
            barY.Enabled = true;
            boxWidth.Enabled = true;
            barWidth.Enabled = true;
            boxHeight.Enabled = true;
            barHeight.Enabled = true;
            R.Enabled = false;
            G.Enabled = false;
            B.Enabled = false;
            rBar.Enabled = false;
            gBar.Enabled = false;
            bBar.Enabled = false;
            butFindPixel.Enabled = false;
            butRun.Enabled = false;
            posX.Text = f7.Location.X.ToString();
            posY.Text = f7.Location.Y.ToString();
            boxWidth.Text = f7.Size.Width.ToString();
            boxHeight.Text = f7.Size.Height.ToString();
            R.Text = "0";
            G.Text = "0";
            B.Text = "0";
            rBar.Value = 0;
            gBar.Value = 0;
            bBar.Value = 0;
            barX.Value = 50;
            barY.Value = 50;
            barWidth.Value = 50;
            barHeight.Value = 50;
            picBaseColor.BackColor = this.BackColor;
            picHighColor.BackColor = this.BackColor;
            picLowColor.BackColor = this.BackColor;
            labBaseColor.Text = "";
            labLowColor.Text = "";
            labHighColor.Text = "";


        }

        private void butFindPixel_Click(object sender, EventArgs e)
        {
            butRun.Enabled = false;
            if (MessageBox.Show("Opravdu chcete spustit vzhledání? Proces může trvat i několik minut", "Spustit?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                f7.findAndPaint(picBaseColor.BackColor, R.Text, G.Text, B.Text);
                f7.upravaPole();
                butRun.Enabled = true;
            }
        }

        private void butRun_Click(object sender, EventArgs e)
        {
            f7.Visible = false;
            /* Process[] p = Process.GetProcessesByName("Mspaint");
             IntPtr mal;*/
            try
            {
                /*mal = p[0].MainWindowHandle;
                SetForegroundWindow(mal);*/

                SetForegroundWindow(agis);
                System.Threading.Thread.Sleep(1000);
                myBitmap = Win32APICall.GetDesktop();
               
            }
            catch (Exception ex) { }


            System.Threading.Thread.Sleep(1000);
            Thread tE;
            tE = new Thread(f7.run);
            tE.Priority = ThreadPriority.Highest;
            tE.Start();
            tE.Join();
            SetForegroundWindow(this.Handle);
            System.Threading.Thread.Sleep(1000);
            f7.Visible = true;
        }


        internal void setClickKey(Keys k)
        {
            switch (k)
            {
                case (Keys.F12):
                    {
                        f7.stop();
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
        }
    }
}
