﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Agis
{
    public partial class Form7 : Form
    {
        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        static extern void mouse_event(uint dwFlags, int dx, int dy, uint dwData, int dwExtraInfo);

        [DllImport("user32.dll")]
        static extern bool SetCursorPos(int X, int Y);

        [DllImport("user32.dll")]
        private static extern IntPtr GetForegroundWindow();

        public const int MOUSEEVENTF_LEFTDOWN = 0x02;
        public const int MOUSEEVENTF_LEFTUP = 0x04;
        public const int MOUSEEVENTF_RIGHTDOWN = 0x08;
        public const int MOUSEEVENTF_RIGHTUP = 0x10;

        Form6 parrent = null;
        private byte[,] paintPixels = null;
        private bool stopPaint;
        List<List<Point>> polygons = null;


        public Form7(Form6 p)
        {
            InitializeComponent();
            parrent = p;
        }

        private void Form7_MouseClick(object sender, MouseEventArgs e)
        {
            parrent.setBaseColor(e.X + this.Location.X, e.Y + this.Location.Y);
        }

        internal void findAndPaint(Color color, string p1, string p2, string p3)
        {
            paintPixels = new byte[this.Size.Width, this.Size.Height];
            int r = int.Parse(p1);
            int g = int.Parse(p2);
            int b = int.Parse(p3);
            for (int i = 0; i < this.Size.Width; i++)
            {
                for (int j = 0; j < this.Size.Height; j++)
                {
                    Color c = parrent.myBitmap.GetPixel(i + this.Location.X, j + this.Location.Y);
                    if (c.R >= color.R - r && c.R <= color.R + r &&
                        c.G >= color.G - g && c.G <= color.G + g &&
                        c.B >= color.B - b && c.B <= color.B + b)
                    {
                        paintPixels[i, j] += 10;
                    }
                }
            }
            for (int i = 0; i < this.Size.Width; i++)
            {
                for (int j = 0; j < this.Size.Height; j++)
                {
                    if (paintPixels[i, j] >= 10)
                        round(i, j);
                }
            }
            bool again = true;
            do
            {
                again = insertSurrounded();
            } while (again);
            do
            {
                again = removeSolitare();
            } while (again);
            this.Refresh();
        }

        private bool removeSolitare()
        {
            bool res = false;
            for (int i = 0; i < this.Size.Width; i++)
            {
                for (int j = 0; j < this.Size.Height; j++)
                {
                    if (paintPixels[i, j] >= 10 && paintPixels[i, j] <= 13)
                    {
                        paintPixels[i, j] -= 10;
                        res = true;
                        try
                        {
                            paintPixels[i - 1, j - 1] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i - 1, j] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i - 1, j + 1] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i, j - 1] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i, j + 1] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i + 1, j - 1] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i + 1, j] -= 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i + 1, j + 1] -= 1;
                        }
                        catch (Exception ex) { }
                    }
                }
            }
            return res;
        }

        private bool insertSurrounded()
        {
            bool res = false;
            for (int i = 0; i < this.Size.Width; i++)
            {
                for (int j = 0; j < this.Size.Height; j++)
                {
                    if (paintPixels[i, j] >= 6 && paintPixels[i, j] <= 8)
                    {
                        paintPixels[i, j] += 10;
                        res = true;
                        try
                        {
                            paintPixels[i - 1, j - 1] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i - 1, j] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i - 1, j + 1] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i, j - 1] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i, j + 1] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i + 1, j - 1] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i + 1, j] += 1;
                        }
                        catch (Exception ex) { }
                        try
                        {
                            paintPixels[i + 1, j + 1] += 1;
                        }
                        catch (Exception ex) { }
                    }
                }
            }
            return res;
        }

        private void round(int i, int j)
        {
            try
            {
                paintPixels[i - 1, j - 1] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i - 1, j] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i - 1, j + 1] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i, j - 1] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i, j + 1] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i + 1, j - 1] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i + 1, j] += 1;
            }
            catch (Exception ex) { }
            try
            {
                paintPixels[i + 1, j + 1] += 1;
            }
            catch (Exception ex) { }
        }

        private void Form7_Paint(object sender, PaintEventArgs e)
        {
            if (paintPixels != null)
            {
                Image im = new Bitmap(this.Size.Width, this.Size.Height);
                Graphics g1 = Graphics.FromImage(im);
                Brush bg = new SolidBrush(Color.Green);
                Brush br = new SolidBrush(Color.Red);
                for (int i = 0; i < this.Size.Width; i++)
                {
                    for (int j = 0; j < this.Size.Height; j++)
                        if (paintPixels[i, j] >= 10 && paintPixels[i, j] < 18)
                            g1.FillRectangle(bg, i, j, 1, 1);
                        else if (paintPixels[i, j] == 18)
                            g1.FillRectangle(br, i, j, 1, 1);
                }
                if (polygons != null)
                {
                    int ind = 0;
                    foreach (List<Point> a in polygons)
                    {
                        foreach (Point poi in a)
                        {
                            g1.FillRectangle(brushSelect(ind), poi.X, poi.Y, 1, 1);
                        }
                        ind += 1;
                    }
                }
                e.Graphics.DrawImage(im, new Point(0, 0));
            }
        }

        private Brush brushSelect(int i)
        {
            i = i % 7;
            switch (i)
            {
                case 0: { return new SolidBrush(Color.Red); }
                case 1: { return new SolidBrush(Color.Green); }
                case 2: { return new SolidBrush(Color.Blue); }
                case 3: { return new SolidBrush(Color.Yellow); }
                case 4: { return new SolidBrush(Color.Magenta); }
                case 5: { return new SolidBrush(Color.Cyan); }
                case 6: { return new SolidBrush(Color.Black); }
                default: { return new SolidBrush(Color.White); }
            }
        }

        internal void run(object obj)
        {
            stopPaint = false;
            int x = this.Location.X;
            int y = this.Location.Y;
            if (!stopPaint)
            {
                foreach (List<Point> a in polygons)
                {
                    if (a.Count > 10)
                    {
                        if (!stopPaint)
                        {
                            foreach (Point poi in a)
                            {
                                if (!stopPaint)
                                {
                                    SetCursorPos(poi.X + x, poi.Y + y);
                                    System.Threading.Thread.Sleep(1000);
                                    mouse_event(MOUSEEVENTF_LEFTDOWN |MOUSEEVENTF_LEFTUP, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                              //      mouse_event(, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                                }
                            }
                            mouse_event(MOUSEEVENTF_LEFTDOWN, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                            mouse_event(MOUSEEVENTF_LEFTUP, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                            System.Threading.Thread.Sleep(5000);
                        }
                    }
                }
            }

        }

        internal void stop()
        {
            stopPaint = true;
            SetForegroundWindow(parrent.Handle);
            SetForegroundWindow(this.Handle);
        }

        internal void upravaPole()
        {
            polygons = new List<List<Point>>();
            int polIndex = 0;
            for (int i = 0; i < this.Size.Width; i++)
            {
                for (int j = 0; j < this.Size.Height; j++)
                {
                    if (paintPixels[i, j] == 18)
                        paintPixels[i, j] = 0;
                    if (paintPixels[i, j] >= 10)
                    {
                        polygons.Add(new List<Point>());
                        addPixel(polIndex, i, j);
                        polIndex += 1;
                    }
                }
            }
            List<List<Point>> polygons2 = new List<List<Point>>();
            foreach (List<Point> a in polygons)
            {
                Point p=new Point(int.MaxValue,int.MaxValue);
                if (a.Count > 10)
                {
                    polygons2.Add(new List<Point>());
                    foreach (Point poi in a)
                    {
                        if (p.X == int.MaxValue)
                        {
                            polygons2[polygons2.Count-1].Add(poi);
                        }
                        else if (p.X != poi.X && p.Y != poi.Y)
                        {
                            break;
                        }
                        else  if (poi.X != polygons2[polygons2.Count - 1][polygons2[polygons2.Count - 1].Count - 1].X && poi.Y != polygons2[polygons2.Count - 1][polygons2[polygons2.Count - 1].Count - 1].Y)
                        {
                            polygons2[polygons2.Count - 1].Add(p);
                        }
 p = poi;
                    }
                }
                polygons2[polygons2.Count - 1].Add(p);
            }
            polygons = polygons2;
            this.Refresh();
        }

        private void addPixel(int index, int i, int j)
        {
            if (paintPixels[i, j] == 18)
                paintPixels[i, j] = 0;
            if (paintPixels[i, j] >= 10)
            {
                polygons[index].Add(new Point(i, j));
                paintPixels[i, j] = 0;
                try
                {
                    if (paintPixels[i - 1, j] >= 10)
                    {
                        addPixel(index, i - 1, j);
                        //  return;
                    }
                }
                catch (Exception ex) { }
                try
                {
                    if (paintPixels[i, j - 1] >= 10)
                    {
                        addPixel(index, i, j - 1);
                        //return;
                    }
                }
                catch (Exception ex) { }
                try
                {

                    if (paintPixels[i, j + 1] >= 10)
                    {
                        addPixel(index, i, j + 1);
                        // return;
                    }
                }
                catch (Exception ex) { }
                try
                {
                    if (paintPixels[i + 1, j] >= 10)
                    {
                        addPixel(index, i + 1, j);
                        //  return;
                    }
                }
                catch (Exception ex) { }
            }
        }
    }
}
