﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace Agis
{
    public class mouseCapture
    {
        private static LowLevelMouseProc proc = HookCallback;
        private static IntPtr hookID = IntPtr.Zero;

        public static LowLevelMouseProc getProc()
        {
            return proc;
        }
        public static IntPtr getHook()
        {
            return hookID;
        }
        public static void setProc(LowLevelMouseProc p)
        {
            proc = p;
        }
        public static void setHook(IntPtr h)
        {
            hookID = h;
        }
        /* public static void Main()
         {
             _hookID = SetHook(_proc);
             Application.Run();
             UnhookWindowsHookEx(_hookID);
         }*/

        public static IntPtr SetHook(LowLevelMouseProc proc)
        {
            using (Process curProcess = Process.GetCurrentProcess())
            using (ProcessModule curModule = curProcess.MainModule)
            {
                return SetWindowsHookEx(WH_MOUSE_LL, proc, GetModuleHandle(curModule.ModuleName), 0);
            }
        }

        public delegate IntPtr LowLevelMouseProc(int nCode, IntPtr wParam, IntPtr lParam);

        private static IntPtr HookCallback(int nCode, IntPtr wParam, IntPtr lParam)
        {
            if (nCode >= 0 && MouseMessages.WM_LBUTTONDOWN == (MouseMessages)wParam)
            {
                MSLLHOOKSTRUCT hookStruct = (MSLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(MSLLHOOKSTRUCT));
                if (Program.f.f3 != null)
                {
                    Program.f.f3.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_LBUTTONDOWN);
                }
                if (Program.f.f8 != null)
                {
                    Program.f.f8.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_LBUTTONDOWN);
                }
            }
            if (nCode >= 0 && MouseMessages.WM_RBUTTONDOWN == (MouseMessages)wParam)
            {
                MSLLHOOKSTRUCT hookStruct = (MSLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(MSLLHOOKSTRUCT));
                if (Program.f.f3 != null)
                {
                    Program.f.f3.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_RBUTTONDOWN);
                }
                if (Program.f.f8 != null)
                {
                    Program.f.f8.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_RBUTTONDOWN);
                }
            }
            if (nCode >= 0 && MouseMessages.WM_LBUTTONUP == (MouseMessages)wParam)
            {
                MSLLHOOKSTRUCT hookStruct = (MSLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(MSLLHOOKSTRUCT));
                if (Program.f.f3 != null)
                {
                    Program.f.f3.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_LBUTTONUP);
                }
                if (Program.f.f8 != null)
                {
                    Program.f.f8.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_LBUTTONUP);
                }
            }
            if (nCode >= 0 && MouseMessages.WM_RBUTTONUP == (MouseMessages)wParam)
            {
                MSLLHOOKSTRUCT hookStruct = (MSLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(MSLLHOOKSTRUCT));
                if (Program.f.f3 != null)
                {
                    Program.f.f3.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_RBUTTONUP);
                }
                if (Program.f.f8 != null)
                {
                    Program.f.f8.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_RBUTTONUP);
                }
            }
            if (nCode >= 0 && MouseMessages.WM_MOUSEMOVE == (MouseMessages)wParam)
            {
                MSLLHOOKSTRUCT hookStruct = (MSLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(MSLLHOOKSTRUCT));
                if (Program.f.f3 != null)
                {
                    Program.f.f3.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_MOUSEMOVE);
                }
                if (Program.f.f8 != null)
                {
                    Program.f.f8.setClick(hookStruct.pt.x, hookStruct.pt.y, MouseMessages.WM_MOUSEMOVE);
                }
            }
            return CallNextHookEx(hookID, nCode, wParam, lParam);
        }

        private const int WH_MOUSE_LL = 14;

        public enum MouseMessages
        {
            WM_LBUTTONDOWN = 0x0201,
            WM_LBUTTONUP = 0x0202,
            WM_MOUSEMOVE = 0x0200,
            WM_MOUSEWHEEL = 0x020A,
            WM_RBUTTONDOWN = 0x0204,
            WM_RBUTTONUP = 0x0205
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct POINT
        {
            public int x;
            public int y;
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct MSLLHOOKSTRUCT
        {
            public POINT pt;
            public uint mouseData;
            public uint flags;
            public uint time;
            public IntPtr dwExtraInfo;
        }

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern IntPtr SetWindowsHookEx(int idHook,
            LowLevelMouseProc lpfn, IntPtr hMod, uint dwThreadId);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool UnhookWindowsHookEx(IntPtr hhk);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern IntPtr CallNextHookEx(IntPtr hhk, int nCode,
            IntPtr wParam, IntPtr lParam);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern IntPtr GetModuleHandle(string lpModuleName);
    }
}
